//---------------------------------------------------------------------------
#pragma hdrstop
#include "ChipFunctions.h"      //      
#include "MainProgram.h"        //      
#include "FormFunctions.h"      //      
#include "SendMsgFunctions.h"   //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//---   -------------------------------------------------
//---------------------------------------------------------------------------
chip  SelectedChip;     //  
//---------------------------------------------------------------------------
//---       ------------------------
//---------------------------------------------------------------------------
void InitChip(unsigned char FamilyCode)
{ //   

  switch(FamilyCode)
  { case 0x1:   SendMsgToLog(0x200,"W25Q08.");                  //   W25Q08
                SelectedChip.Name               = "8M-BIT";     //  
                SelectedChip.ImageName          = "W25Qxx.jpg"; //    
                SelectedChip.Model              = 0x01;         //  
                SelectedChip.Size               = 1048576;      //  
                break;
    case 0x2:   SendMsgToLog(0x200,"W25Q16.");                  //   W25Q16
                SelectedChip.Name               = "16M-BIT";    //  
                SelectedChip.ImageName          = "W25Qxx.jpg"; //    
                SelectedChip.Model              = 0x02;         //  
                SelectedChip.Size               = 2097152;      //  
                break;
    case 0x3:   SendMsgToLog(0x200,"W25Q32.");                  //   W25Q32
                SelectedChip.Name               = "32M-BIT";    //  
                SelectedChip.ImageName          = "W25Qxx.jpg"; //    
                SelectedChip.Model              = 0x03;         //  
                SelectedChip.Size               = 4194304;      //  
                break;
    case 0x4:   SendMsgToLog(0x200,"W25Q64.");                  //   W25Q64
                SelectedChip.Name               = "64M-BIT";    //  
                SelectedChip.ImageName          = "W25Qxx.jpg"; //    
                SelectedChip.Model              = 0x04;         //  
                SelectedChip.Size               = 8388608;      //  
                break;
    default:    break;
  }
  //  
  memset(SelectedChip.Data,255,SelectedChip.Size);      //    FF-
  //     
  InitForm();
}
//---------------------------------------------------------------------------
//---    BIN-   --------------------------------
//--- (Area = 0 -   , Area = 1 -   ) ------------
//---------------------------------------------------------------------------
void LoadFromBinFileToMemory(AnsiString FilePath, bool Area)
{ TFileStream* fs;                              //    
  int SizeOfFile;
  unsigned int StartAddress=0, EndAddress=0;
  int AreaSize;                                 //   

  fs=new TFileStream(FilePath,fmOpenRead);      //        
  SizeOfFile=fs->Seek(0,soFromEnd);             //     
  //   ,    ,   
  if(Area)
  {     StartAddress=StrToInt(Form1->Edit2->Text)*65536+StrToInt(Form1->Edit3->Text)*4096;
        EndAddress=StrToInt(Form1->Edit4->Text)*65536+(StrToInt(Form1->Edit5->Text)+1)*4096-1;
        AreaSize=EndAddress-StartAddress+1;     //  =   
  }
  else
  {     AreaSize=SelectedChip.Size;             //  =  
  }
  //   ,     
  if(SizeOfFile>AreaSize)
  {    SizeOfFile=AreaSize;                     //       -    ,  
  }
  fs->Seek(0,soFromBeginning);                  //     
  //     
  fs->Read(&SelectedChip.Data[StartAddress],SizeOfFile); //       
  delete fs;
  Form1->StaticText1->Caption=FilePath;         //      StaticText1
  SendMsgToLog(0x201,IntToStr(SizeOfFile));     //     
}
//---------------------------------------------------------------------------
//---      BIN- ---------------------------------
//---------------------------------------------------------------------------
void SaveFromMemoryToBinFile(AnsiString FilePath, bool Area)
{ TFileStream* fs;                              //    
  unsigned int StartAddress=0, EndAddress=0;
  int AreaSize;                                 //   

  //    
  if(Area)
  {     StartAddress=StrToInt(Form1->Edit2->Text)*65536+StrToInt(Form1->Edit3->Text)*4096;
        EndAddress=StrToInt(Form1->Edit4->Text)*65536+(StrToInt(Form1->Edit5->Text)+1)*4096-1;
        AreaSize=EndAddress-StartAddress+1;     //  =   
  }
  else
  {     AreaSize=SelectedChip.Size;             //  =  
  }
  //  
  fs=new TFileStream(FilePath,fmCreate|fmOpenWrite);
  fs->Write(&SelectedChip.Data[StartAddress],AreaSize);
  delete fs;
  Form1->StaticText1->Caption=FilePath;
  SendMsgToLog(0x202,IntToStr(AreaSize));      //     
}
//---------------------------------------------------------------------------
