//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "MainProgram.h"
#include "ProgressBar.h"        //   
#include "About.h"              //    About
#include "SendMsgFunctions.h"   //     
#include "PortFunctions.h"      //      
#include "FormFunctions.h"      //      
#include "ChipFunctions.h"      //      
#include "W25Qxx.h"             //     
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------
//---   -------------------------------------------------
//---------------------------------------------------------------------------
TForm1 *Form1;  // 
AnsiString FilePath;
bool BS_FLAG;
//---------------------------------------------------------------------------
//---   COM- -----------------------------------------
//---------------------------------------------------------------------------
void OpenPort()
{ //  .     nt-  
  // "\\.\PortName",      \    2 
  char PortName[100]="\\\\.\\";
  strcat(PortName,Form1->ComboBox1->Text.c_str());
  OpenCom(PortName);                    //     
  if(Port!=INVALID_HANDLE_VALUE)
  { Form1->Button3->Enabled=false;
    Form1->Button4->Enabled=true;
    EnableControlButtons();                     //   
    SendMsgToLog(0x4,AnsiString(PortName));     //  COM-
  }
  else  SendMsgToLog(0x2,"");                   // COM-  
}
//---------------------------------------------------------------------------
//---   COM- -----------------------------------------
//---------------------------------------------------------------------------
void ClosePort()
{ CloseHandle(Port);
  Port=INVALID_HANDLE_VALUE;
  Form1->Button3->Enabled=true;
  Form1->Button4->Enabled=false;
  DisableControlButtons();              //   
  SendMsgToLog(0x5,"");                 // COM- 
}
//***************************************************************************
//---      -------------------------------------------
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{ Form1->AutoSize=true;
  Button3->Enabled=true;
  Button4->Enabled=false;
  DisableControlButtons();
  SelectedChip.Model=0;   //     
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{ OpenPort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button4Click(TObject *Sender)
{ ClosePort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ComboBox1Change(TObject *Sender)
{ //   ,    
  if(Port!=INVALID_HANDLE_VALUE) ClosePort();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Exit1Click(TObject *Sender)
{ if(Port!=INVALID_HANDLE_VALUE) ClosePort();
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::About1Click(TObject *Sender)
{ AboutBox->Show();
}
//---------------------------------------------------------------------------
//---   -----------------------------------------------------------
void __fastcall TForm1::N25X81Click(TObject *Sender)
{ InitChip(1);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::W25X161Click(TObject *Sender)
{ InitChip(2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::W25X321Click(TObject *Sender)
{ InitChip(3);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::W25X641Click(TObject *Sender)
{ InitChip(4);
}
//***************************************************************************
//---     ------------------------------------------
//***************************************************************************
//---------------------------------------------------------------------------
//---         ( ) ----------
//---------------------------------------------------------------------------
void __fastcall TForm1::Open1Click(TObject *Sender)
{ AnsiString FilePath;

  if(OpenDialog1->Execute())
  { FilePath=OpenDialog1->FileName;             //    
    LoadFromBinFileToMemory(FilePath, false);   //        
  }
}
//---------------------------------------------------------------------------
//---        ( ) -------
//---------------------------------------------------------------------------
void __fastcall TForm1::Opentoselected1Click(TObject *Sender)
{ AnsiString FilePath;

  if(OpenDialog1->Execute())
  { FilePath=OpenDialog1->FileName;             //    
    LoadFromBinFileToMemory(FilePath, true);    //        
  }
}
//---------------------------------------------------------------------------
//---      -----------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Saveas1Click(TObject *Sender)
{ if(SaveDialog1->Execute()) //     
  { FilePath=SaveDialog1->FileName;
    SaveFromMemoryToBinFile(FilePath, false);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Save1Click(TObject *Sender)
{ if(FilePath.Length())     //     
  { if(MessageBox(Form1->Handle,"   , ?","", MB_OKCANCEL|MB_ICONQUESTION)==IDOK)
    { SaveFromMemoryToBinFile(FilePath, false);
    }
  }
  else if(SaveDialog1->Execute()) //     (  )
  { FilePath=SaveDialog1->FileName;
    SaveFromMemoryToBinFile(FilePath, false);
  }
}
//---------------------------------------------------------------------------
//---      ------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Saveselectedas1Click(TObject *Sender)
{ if(SaveDialog1->Execute()) //     
  { FilePath=SaveDialog1->FileName;
    SaveFromMemoryToBinFile(FilePath, true);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Saveselected1Click(TObject *Sender)
{ if(FilePath.Length())     //     
  { if(MessageBox(Form1->Handle,"   , ?","", MB_OKCANCEL|MB_ICONQUESTION)==IDOK)
    { SaveFromMemoryToBinFile(FilePath, true);
    }
  }
  else if(SaveDialog1->Execute()) //     (  )
  { FilePath=SaveDialog1->FileName;
    SaveFromMemoryToBinFile(FilePath, true);
  }
}
//---------------------------------------------------------------------------
//---        ---------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Savelog1Click(TObject *Sender)
{ AnsiString FilePath;                          //    

  if(SaveDialog1->Execute())                    //     (  )
  { FilePath=SaveDialog1->FileName;             //     
    //    
    Form1->RichEdit1->Lines->SaveToFile(FilePath);   //    RichEdit9
  }
}
//---------------------------------------------------------------------------
//---   STATUS1, STATUS2 ---------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::EditStatusKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{ char *Charset1="0123456789abcdefABCDEF";      //  
  char Symbol;                                  //   
  int Position;                                 //  
  TEdit *ptEdit;                                //       

  ptEdit=(TEdit*)Sender;                        //      
  Position=ptEdit->SelStart;                    //    
  switch(Key)
  { //  backspace ***********************************
    case 8:     Position-=1;                    //  
                if(Position<0)  Position=2;     //   <0,     
                else
                { ptEdit->SelStart=Position;    //  
                  ptEdit->SelLength=1;          //  1 
                  Symbol=0x46;                  //    F
                  ptEdit->SelText=Symbol;       // 
                }
                //     
                ptEdit->SelStart=Position;      //     
                ptEdit->SelLength=0;            //  
                break;
    //   *************************************
     case 0x25:
     case 0x26:
     case 0x27:
     case 0x28: return;
     //  delete **************************************
     case 0x2E: Key=0x46;                       //   F,      
     //     ***********************
     default:   if(Position>1)  Position=-1;    //   >1,     
                else if(strchr(Charset1,Key))   //     
                { ptEdit->SelStart=Position;    //     
                  ptEdit->SelLength=1;          //  1 
                  Symbol=Key;
                  ptEdit->SelText=Symbol;       //    
                  ptEdit->SelStart=Position;    //     
                  ptEdit->SelLength=1;          //  1 
                  ptEdit->SelText=UpperCase(ptEdit->SelText); //      
                }
                //     
                Position+=1;                    //   
                ptEdit->SelStart=Position;      //     
                ptEdit->SelLength=0;            //  
  }
  Key=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::EditStatusKeyPress(TObject *Sender, char &Key)
{ Key=0;
}
//---------------------------------------------------------------------------
//---      
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit2Change(TObject *Sender)
{ unsigned int StartAddress;

  if((Edit2->Text!="") && (Edit3->Text!=""))
  {     StartAddress=StrToInt(Edit2->Text)*65536+StrToInt(Edit3->Text)*4096;
        Edit6->Text=IntToHex(int(StartAddress),8);
  }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Edit4Change(TObject *Sender)
{ unsigned int EndAddress;

  if((Edit4->Text!="") && (Edit5->Text!=""))
  {     EndAddress=StrToInt(Edit4->Text)*65536+(StrToInt(Edit5->Text)+1)*4096-1;
        Edit7->Text=IntToHex(int(EndAddress),8);
  }
}
//***************************************************************************
//---    --------------------------------------------------
//***************************************************************************
//---------------------------------------------------------------------------
//---    ----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{ unsigned int StartAddress=0, EndAddress=0, CurrentAddress, Sectors;

  StartAddress=StrToInt(Edit2->Text)*65536+StrToInt(Edit3->Text)*4096;
  EndAddress=StrToInt(Edit4->Text)*65536+(StrToInt(Edit5->Text)+1)*4096-1;
  CurrentAddress=StartAddress;
  Sectors=(EndAddress-StartAddress)/4096+1;     //   ,    

  SendMsgToLog(0x142,"");                       //   
  SendStartTimeToLog();                         //      
  // -
  Application->CreateForm(__classid(TLBar),&LBar);      //    -
  LBar->Show();                                 //     
  //*******************************************************************
  if(!W25Qxx_WriteEnable())                                     //  Write Enable,   - 
  {     SendMsgToLog(0x14D,"");                                 // error
        return;
  }
  //***  write protect  status register (   ) ***
  if(!W25Qxx_WriteStatus(0,0))                                  //  Write Status,   - 
  {     SendMsgToLog(0x14D,"");                                 // error
        return;
  }
  //***           
  //        
  for(unsigned int i=0; i<Sectors; i++)
  {     //*** WRITE ENABLE ***
        if(!W25Qxx_WriteEnable())                               //  Write Enable,   - 
        {       SendMsgToLog(0x14D,"");                         // error
                return;
        }
        //*** ERASE SECTOR (max 300 ) ***
        if(!W25Qxx_EraseSector(CurrentAddress))                 //  Sector Erase,   - 
        {       SendMsgToLog(0x14D,"");                         // error
                return;
        }
        //    (max 3   )
        for(unsigned int j=0;j<16;j++)
        {       //*** WRITE ENABLE ***
                if(!W25Qxx_WriteEnable())                       //  Write Enable,   - 
                {       SendMsgToLog(0x14D,"");                 // error
                        return;
                }
                //*** WRITE PAGE ***
                if(!W25Qxx_WritePage(CurrentAddress))           //  Write Enable,   - 
                {       SendMsgToLog(0x14D,"");                 // error
                        return;
                }
                CurrentAddress=CurrentAddress+256;
        }
        LBar->ProgressBar1->Position=100*i/Sectors;             //    -
  }
  // -
  LBar->Free();                                                 //    -

  SendMsgToLog(0x14C,"");                                       // success
  SendEndTimeToLog();                                           //      
  MessageBox(NULL," ","OK",MB_OK);
}
//---------------------------------------------------------------------------
//---    ----------------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{ unsigned int StartAddress=0, EndAddress=0;

  //      
  StartAddress=StrToInt(Edit2->Text)*65536+StrToInt(Edit3->Text)*4096;
  EndAddress=StrToInt(Edit4->Text)*65536+(StrToInt(Edit5->Text)+1)*4096-1;

  SendMsgToLog(0x143,"");                                       //   
  SendStartTimeToLog();                                         //      
  // -
  Application->CreateForm(__classid(TLBar),&LBar);              //    -
  LBar->Show();                                                 //     

  if(!W25Qxx_ReadData(StartAddress, EndAddress))                //  Read Data,   - 
  {     SendMsgToLog(0x14D,"");                                 // error
        return;
  }

  // -
  LBar->Free();                                                 //    -

  SendMsgToLog(0x14C,"");                                       // success
  SendEndTimeToLog();                                           //      
  MessageBox(NULL," ","OK",MB_OK);
}
//---------------------------------------------------------------------------
//---   STATUS1, STATUS2 -------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button6Click(TObject *Sender)
{ unsigned char Status1, Status2;
  AnsiString TempStr;           //  
  char *InHexBuf, TempBuf[1];   //  

  TempStr=LowerCase(Form1->Edit8->Text);        //  Status1  
  InHexBuf=TempStr.c_str();                     //     Status1 (  )
  HexToBin(InHexBuf,TempBuf,1);                 //     ()
  Status1=TempBuf[0];                           //     Status1

  TempStr=LowerCase(Form1->Edit9->Text);        //  Status2  
  InHexBuf=TempStr.c_str();                     //     Status2 (  )
  HexToBin(InHexBuf,TempBuf,1);                 //     ()
  Status1=TempBuf[0];                           //     Status2

  SendMsgToLog(0x14A,"");                       //    Status 1, Status2
  if(!W25Qxx_WriteStatus(Status1, Status2))     //  Write Status,   - 
  {     SendMsgToLog(0x14D,"");                 // error
        return;
  }

  SendMsgToLog(0x14C,"");                       // success
}
//---------------------------------------------------------------------------
//---   STATUS1, STATUS2 -------------------------------------
//---------------------------------------------------------------------------
void __fastcall TForm1::Button5Click(TObject *Sender)
{ W25Qxx_RS OutputData;                 //   
  char TempBuf[1], OutHexBuf[3];        //  

  SendMsgToLog(0x14B,"");               //    Status 1, Status2
  OutputData = W25Qxx_ReadStatus();     //  Read Status
  if(!OutputData.Success)               //   - 
  {     SendMsgToLog(0x14D,"");         // error
        return;
  }

  TempBuf[0]=OutputData.Status1;        //    Status 1
  BinToHex(TempBuf,OutHexBuf,1);        //    
  OutHexBuf[2]=0;                       //    
  Form1->Edit8->Text = OutHexBuf;       //   Status 1  

  TempBuf[0]=OutputData.Status2;        //    Status 2
  BinToHex(TempBuf,OutHexBuf,1);        //    
  OutHexBuf[2]=0;                       //    
  Form1->Edit9->Text = OutHexBuf;       //   Status 2  

  SendMsgToLog(0x14C,"");               // success

  //     
  W25Qxx_StatusDecode(OutputData.Status1, OutputData.Status2);
}
//---------------------------------------------------------------------------

